// -*- tab-width:2 ; indent-tabs-mode:nil -*-
//:: cases ForkJoinTask

//begin(all)
public class ForkJoinTask /* extends Future */ {
  /*@
    public static resource preExec() = true;
    public resource execToken() = Value(this.done) ** PointsTo(this.done.val, 1/2, false)
                                  ** Perm(this.value, 1);
    public resource getToken() = Perm(this.dummy, 1);
    public resource postGet(ValueContainer value) = PointsTo(value.x, 1, 5);

    private boolean dummy;
    private frac getExecuted;
    // begin(invariant)
    resource csl_invariant() = Value(this.done) ** Perm(this.done.val, 1/2)
        ** Perm(this.getExecuted, 1)
        ** (this.getExecuted != none ==> Perm(this.dummy, this.getExecuted))
        ** (!this.done.val ==> this.getExecuted == none)
        ** (this.done.val ==> (Value(this.done.val) ** Value(this.value)
                           ** [1 - this.getExecuted]postGet(this.value)));
    // end(invariant)
  @*/

  private AtomicBoolean done;
  private ValueContainer value;

  /*@
    ensures  execToken();
    ensures  getToken();
  @*/
  public ForkJoinTask(){
    this.done = new AtomicBoolean();
    //@ this.getExecuted = none;
    //@ fold this.getToken();
    //@ fold this.execToken();
    //@ refute false; //skip(all)
  }

  /*@
    requires preExec();
    ensures  postGet(\result);
  @*/
  private ValueContainer exec() {
    ValueContainer res = new ValueContainer();
    res.set(5);
    //@ fold postGet(res);
    return res;
    //@ refute false; //skip(all)
  }

  /*@
    requires preExec() ** execToken();
    ensures  Value(this.done) ** Value(this.done.val) ** this.done.val;
  @*/
  public void doExec() {
    //@ unfold this.execToken();
    this.value = exec();
    this.done.set(true);
    //@ refute false; //skip(all)
  }

  /*@
    given frac p;
    requires p > none ** [p]getToken();
    ensures  [p]postGet(\result);
  @*/
  public ValueContainer get() {
    boolean d = false;

    //@ loop_invariant d ==> Value(this.done) ** Value(this.done.val) ** this.done.val ** Value(this.value);
    while(!d) {
      d = this.done.get();
    }

    //@ unfold [p]this.getToken();
    /*@
      atomic(this) {
        frac oldGetExecuted; //!\label{frac-assing-separate}!//
        oldGetExecuted = this.getExecuted; //!\label{frac-assing-local}!//
        assert oldGetExecuted + p <= write;
        this.getExecuted = oldGetExecuted + p;
      }
    @*/

    return this.value;
    //@ refute false; //skip(all)
  }
}
//end(all)
