// -*- tab-width:2 ; indent-tabs-mode:nil -*-
//:: cases ForkJoinTask

//begin(all)
/**
 * Simple container to store a integer value.
 */
public class ValueContainer {
  private int x;
  
  /*@
    ensures PointsTo(x, 1, 0);
  @*/
  public ValueContainer() {
    this.x = 0;
  }

  //begin(get)
  /*@
    given frac p;
    given int res;
    requires p != none ** PointsTo(x, p, res); //!\label{get-precondition}!//
    ensures PointsTo(x, p, res) ** \result == res;
  @*/
  public int get() {
    return x;
  }
  //end(get)
  
  /*@
    requires Perm(x, 1);
    ensures PointsTo(x, 1, newX);
  @*/
  public int set(int newX) {
    this.x = newX;
  }
}
//end(all)
