// -*- tab-width:2 ; indent-tabs-mode:nil -*-
//:: case QueueApplication

//begin(all)
public class AbstractQueue {

// begin(get)
//@ History hist;
//@ boolean hist_active;
// end(get)

  /*@ given History hist;
   requires HPerm(hist.q,1) ** hist.q==seq<int>{};
   ensures Value(this.hist) ** this.hist == hist
     ** PointsTo(hist_active,1/2,true); @*/
  public AbstractQueue(){
    //@ assume false;
  }
  

  /*@
    given frac p;
    given process P;
    requires Value(hist) ** p!=none
      ** PointsTo(hist_active,p/2,true) ** Hist(hist,p,P);
    ensures  Value(hist) ** p!=none
      ** PointsTo(hist_active,p/2,true) ** Hist(hist,p,P*hist.put(val));
  @*/
  public void put(int val);

// begin(get)
/*@ given frac p;   given process P;
      requires Value(hist) ** Hist(hist,p,P)
         ** p!=none ** PointsTo(hist_active,p/2,true);
      ensures  Value(hist) ** Hist(hist,p,P*hist.get(\result))
         ** p!=none ** PointsTo(hist_active,p/2,true);
@*/ public int get();
// end(get)

/*@
  requires Value(hist) ** PointsTo(hist_active,1/2,true);
  ensures Value(hist)  ** PointsTo(hist_active,1/2,false)** HPerm(hist.q,1);
  void end_history();
@*/
  
}
//end(all)

