// -*- tab-width:2 ; indent-tabs-mode:nil -*-
//:: case FutureQueueApplication
//:: tool silicon
//:: options --check-history

/* To verify this example:

  vct --silver=silicon --check-history FutureQueue.java SpecifiedThread.java FutureWorker.java AbstractFutureQueue.java FutureMain.java
  
 */
//begin(all)
public class Main {


  /*@
    given seq<int> contents;
    requires input.length==|contents|;
    requires output.length==|contents|;
    requires (\forall* int i; 0 <= i && i < |contents|;Perm(input[i],1));
    requires (\forall  int i; 0 <= i && i < |contents|;input[i]==contents[i]);
    requires (\forall* int i; 0 <= i && i < |contents|;Perm(output[i],1));
    requires (\forall  int i; 0 <= i && i < |contents|;output[i]==0);
  @*/
  public static void main(int[] input,int[] output){
    Future fut=new Future();
    //@ fut.q = seq<int>{};
    //@ create fut, fut.feed(contents,contents);
    AbstractFutureQueue q=new AbstractFutureQueue()
    /*@ with { fut=fut; } @*/;
    //@ split q.fut, 1/2, fut.put_all(contents), 1/2, fut.get_all(contents);

    //@ assert AbstractState(fut, q == seq<int>{});
    
    Sender   s=new Sender(q,input)/*@ with {vals=contents;} @*/;
    Receiver r=new Receiver(q,output)/*@ with {vals=contents;} @*/;
    r.start();
    s.start();

    s.join()/*@ with { p = 1; } @*/;
    //@ open s.postJoin@Sender(1);
    //@ unfold s.postJoin@Sender(1);
   
    r.join()/*@ with { p = 1; } @*/;
    //@ open r.postJoin@Receiver(1);
    //@ unfold r.postJoin@Receiver(1);
  
    //@ assert Future(fut,1/2,empty);
    //@ assert Future(fut,1/2,empty);
    
    //@ merge fut, 1/2, empty, 1/2, empty;
    //@ q.end_future();
    //@ destroy fut;

    // Derive some intermediate results.
    //@ assert seq<int>{} + s.vals == r.vals + fut.q;
    //@ assert fut.q == seq<int>{};
    // Assume a few extra rules about seqeunces.
    //@ assume (\forall seq<int> L; true ; seq<int>{} + L == L );
    //@ assume (\forall seq<int> L; true ; L + seq<int>{} == L );
    // Verify that the input and output are equal.
    //@ assert s.vals == r.vals;
  }
}
//end(all)


