// -*- tab-width:2 ; indent-tabs-mode:nil -*-
//:: case QueueApplication

//:: case QueueDefined
//:: tool silicon
//:: options --check-defined

//:: case QueueAxioms
//:: tool silicon
//:: options --check-axioms

/*
  vct --silver=silicon --check-axioms HistoryQueue.java
  vct --silver=silicon --check-defined HistoryQueue.java
*/
// begin(put) begin(get) begin(all)
public class History {/*@
    seq<int> q;
    
// end(get)
    modifies q;
    ensures  q==\old(q)+seq<int>{e};
    process  put(int e);
    
    modifies q;
    ensures  q==\old(q)+es;
    process  put_all(seq<int> es)=
      |es| == 0?empty:(put(head(es))*put_all(tail(es)));

    ensures put_all(es)*put(e)==put_all(es+seq<int>{e}); #\label{putall begin}#
    void put_lemma(seq<int> es,int e){
      if (|es|>0){
        put_lemma(tail(es),e);
        assert tail(es+seq<int>{e}) == tail(es)+seq<int>{e};
      }
    } #\label{putall end}#
// end(put)

//begin(get)
    modifies q;    ensures  \old(q)==seq<int>{e}+q;
    ensures  (\forall seq<int> q2;true; // skip(get)
                \old(q)+q2==seq<int>{e}+(q+q2)); // skip(get)
             // the \forall works around a tool issue. // skip(get)
    process  get(int e);
    
    modifies q;    ensures  \old(q)==es+q;
    process  get_all(seq<int> es)=
      |es| == 0?empty:(get(head(es))*get_all(tail(es)));

    ensures get_all(es)*get(e)==get_all(es+seq<int>{e}); #\label{getall begin}#
    void get_lemma(seq<int> es,int e){ if (|es|>0){
      get_lemma(tail(es),e);
      assert |es|>0 ; // skip(get)
      assume tail(es+seq<int>{e}) == tail(es)+seq<int>{e}; // skip(get)
    }} #\label{getall end}#
// end(get)
// begin(put) begin(get)

    modifies q;    ensures  \old(q)+input==output+q;#\label{feed def}#
    process  feed(seq<int> input,seq<int> output)=
      put_all(input)||get_all(output);
// end(put) end(get)

    modifies q;    ensures  \old(q)+input==output+q;
    process  feed2(seq<int> output,seq<int> input)=
      get_all(output)||put_all(input);

  @*/
}
//end(all)

