//package mpi;

public class Request {
    /*@
        boolean recv;
        int source;
        int dest;
        int tag;
        int r;
        frac bufp;
        Object buf;

        public resource waitToken() =
            Value(this.recv) **
            Value(this.source) **
            Value(this.dest) **
            Value(this.tag) **
            Value(this.r) **
            Value(this.bufp) **
            Value(this.buf) ** Perm(this.buf[0], this.bufp);
    @*/

    /*@
        given boolean recv;
        given int source;
        given int dest;
        given int tag;
        given int r;
        given frac bufp;
        given Object buf;
        requires recv ==> bufp == write;
        requires Perm(buf[0], bufp);
        ensures waitToken();
        ensures Value(this.source) ** this.source == source **
            Value(this.dest) ** this.dest == dest **
            Value(this.tag) ** this.tag == tag **
            Value(this.r) ** this.r == r **
            Value(this.bufp) ** this.bufp == bufp **
            Value(this.buf) ** this.buf == buf;

    @*/
    Request() {
        /*@
            this.source = source;
            this.dest = dest;
            this.tag = tag;
            this.r = r;
            this.bufp = bufp;
            this.buf = buf;
            fold this.waitToken();
            refute false; //skip(all)
        @*/
    }

    /**
     * Blocks until the operation identified by the request is complete.
     * <p>
     * Java binding of the MPI operation <tt>MPI_WAIT</tt>.
     * <p>
     * After the call returns, the request object becomes inactive.
     *
     * @return status object
     */
// begin(WaitSpec)
    /*@
        given Future fut;
        given frac p;
        given process P(msg);
        requires fut != null ** p != none;
        requires Value(this.recv) ** Value(this.r);
        requires this.waitToken();
        requires !recv ==> Future(fut, p, waitsend(this.r) * P(null));
        requires recv ==> Value(this.source) ** Value(this.dest) **
            Value(this.tag);
        requires recv ==> Future(fut, p,
            \sum(int act_source, int act_tag, Object msg;
                 this.source != ANY_SOURCE ==> act_source == this.source **
                 this.tag != ANY_TAG ==> act_tag == this.tag;
                 waitrecv(act_source, this.dest, msg, act_tag, this.r) *
                 P(msg)));
        ensures Value(bufp) ** Value(buf) ** Perm(buf[0], bufp);
        ensures recv ==> Value(\result.source) ** \result.source == act_source;
        ensures recv ==> Value(\result.tag) ** \result.tag == act_tag;
        ensures recv ==> buf[0] == msg;
        ensures recv ==> valid(act_source, dest, buf[0], act_tag);
        ensures Future(fut, p, P(msg));
    @*/
    public Status Wait() {
        // end(WaitSpec)
        //@ action fut, p, P(msg), fut.wait(act_source, dest, msg, act_tag, r);
        //@ assume valid(act_source, dest, buf[0], act_tag);
        return new Status()
                /*@ with {source = act_source; tag = act_tag;} @*/;
        // begin(WaitSpec)
    }
// end(WaitSpec)
}
