import mpi.Datatype;
import mpi.Intracomm;
import mpi.MPI;
import mpi.MPIException;

public class MPIWrapper {
    public int ANY_SOURCE() {
        return MPI.ANY_SOURCE;
    }

    public Intracomm COMM_WORLD() {
        return MPI.COMM_WORLD;
    }

    public Datatype OBJECT() {
        return MPI.OBJECT;
    }

    /**
     * Initialize MPI.
     *
     * Java binding of the MPI operation <tt>MPI_INIT</tt>.
     *
     * @param args
     *            arguments to <tt>main</tt> method.
     */
    public String[] Init(String[] argv) throws MPIException {
        return MPI.Init(argv);
    }

    /**
     * Finalize MPI.
     *
     * Java binding of the MPI operation <tt>MPI_FINALIZE</tt>.
     */
    public static void Finalize() throws MPIException {
        MPI.Finalize();
    }
}
