import java.io.Serializable;

public abstract class ActiveObject extends Thread {
    private final int objectId;

    public ActiveObject(int objectId) {
        this.objectId = objectId;
    }

    public int getObjectId() {
        return this.objectId;
    }

    public abstract RemoteObject getRemote();

    @Override
    public void run() {

        while (true) {

            ReceivedCall receivedCall = MPAO.receiveCall(objectId);
            Serializable result = this.callMethod(receivedCall.getCall());

            MPAO.sendResult(receivedCall.getSource(),
                    receivedCall.getCall(), result);

        }
    }

    protected abstract Serializable callMethod(Call call);
}
