import java.io.Serializable;
import java.util.Arrays;

public class Call implements Serializable {
    private static final long serialVersionUID = -8236034793367201146L;
    private final int callId;
    private final String signature;
    private final Serializable[] parameters;

// begin(ConstructorSpec)
    /*@
        given int dest;
        given int objectId;
        requires validCall(dest, objectId, signature, paramters);
        ensuers valid(Rank(), dest, this, objectId);
    @*/
    public Call(int callId, String signature, Serializable[] parameters) {
// end(ConstructorSpec)
        this.callId = callId;
        this.signature = signature;
        this.parameters = parameters;
// begin(ConstructorSpec)
    }
// end(ConstructorSpec)

    public int getCallId() {
        return this.callId;
    }

    public Serializable[] getParameters() {
        return this.parameters;
    }

    public String getSignature() {
        return this.signature;
    }

    @Override
    public String toString() {
        return "Call(" + callId + ", " + signature + ", " +
                    Arrays.toString(parameters) + ")";
    }
}
