import java.io.Serializable;

public class FactoryRemote implements RemoteObject {
    private int workerId;

    public FactoryRemote(int workerId) {
        this.workerId = workerId;
    }

    public RemoteFuture<MathRemote> newMath() {
        return new RemoteFuture<MathRemote>(MPAO.callMethod(workerId, MPAO.FACTORY_ID, "newMath", new Serializable[0]));
    }

    public RemoteFuture<MergeSortRemote> newMergeSort() {
        return new RemoteFuture<MergeSortRemote>(
                MPAO.callMethod(workerId, MPAO.FACTORY_ID, "newMergeSort", new Serializable[0]));
    }
}
