import mpi.MPI;

public class MPAOMultiMain {
    public static void main(String[] args) {
        MPI.Init(args);
        MPAO.init();

        if (MPAO.getWorkerId() == 0) {
            System.out.println("Getting Math object...");
            RemoteFuture<MathRemote> f = MPAO.getFactory(1).newMath();
            System.out.println("Request sent.");
            MathRemote math = f.get();
            System.out.println("Got Math object.");

            System.out.println("Calculating 6 / 2...");
            RemoteFuture<Integer> result = math.divide(6, 2);
            System.out.println("Request sent.");

            for (int i = 0; i < 10; i++) {
                new Thread(new Runnable() {

                    @Override
                    public void run() {
                        Thread t = Thread.currentThread();
                        System.out.println(System.currentTimeMillis() + " " + t + ": Getting result...");
                        int r = result.get();
                        System.out.println(System.currentTimeMillis() + " " + t + ": 6 / 2 = " + r);
                    }
                }).start();
                try {
                    Thread.sleep(900);
                } catch (InterruptedException e) {
                    Thread.currentThread().interrupt();
                }
            }

        }

        MPI.COMM_WORLD.Barrier();
        MPI.Finalize();
        System.exit(0);
    }
}
