import java.io.Serializable;
import java.security.InvalidParameterException;

public class MathImpl extends ActiveObject {

    public MathImpl(int objectId) {
        super(objectId);
    }

    /*@
        requires b != 0 ** a % b == 0;
        ensures \result * b == a;
    @*/
    public int divide(int a, int b) {
        return a / b;
    }

    @Override
    protected Serializable callMethod(Call call) {
        Serializable[] parameters = call.getParameters();
        switch (call.getSignature()) {
        case "divide":
            return this.divide((Integer) parameters[0],
                               (Integer) parameters[1]);
        default:
            throw new InvalidParameterException();
        }
    }

    @Override
    public MathRemote getRemote() {
        return new MathRemote(MPAO.getWorkerId(), getObjectId());
    }
}
